#ifndef _DISC_COLONY_H
#define _DISC_COLONY_H

#include "colony.h"
#include "weighted.h"

class ant_dat {
  public:
    int x, y, p, sta, dir ;
} ;

extern double ant_color[] ;

class discrete_colony: public colony {
public:
  int *ants ;
  ant_dat *ant_record ;
  int *n_filled ;
  int *envir ;
  int n_ants ;
  int size_x, size_y ;
  real *no_c_B ;
  multi_nomial *c_a_multi, *dir_multi ;
  real alfa_n ;
  void choose_state( real no_change, real *c, int &st ) ;
  int meeting( int st_a, int st_b ) ;
  int go( int an) ;
  virtual void make_room_for_env() ;
  void make_more_room() ;
  void remove_ant( int an ) ;
  void add_ant( int an, int x, int y, int sta ) ;
  virtual int choose_dir( int sta, int x, int y ) ; 
  virtual int ca_multi_env( int sta, int x, int y ) ;
  virtual int place_free( int x, int y ) ;
  int test_ps() ;
public:
//    discrete_colony() ;
  discrete_colony( char *fname, int total_ants, real a, int x, int y ) ;
  //    discrete_colony( discrete_colony &oc ) ;
  //    discrete_colony &operator=( discrete_colony &oc ) ;
  virtual ~discrete_colony() ;
  int read_population( char *fname ) ;
  int read_interpret( char *com, istream &f ) ;
  void read_cleanup(istream &f) ;
  void setup_c_a_multi() ;
  void setup_c_nB() ;
  void uniform_population() ;
  void transform(real dt = 0.001) ;
  int &ant(int x, int y, int pl) ;
  int &num_ants( int x, int y) ;
  //    real &c_nA( int i) ;
  real &c_nB( int i, int j) ;
  void distribute_ants() ;
  void choose_colony_states() ;
  
  static char *env_states ;
  virtual real &c_a( int i, int j, int st ) ;
  multi_nomial &c_a_multi_a( int x, int y ) ;
  multi_nomial &dir_multi_a( int x, int y) ;
  int &env( int x, int y) ;
  void test_trans() ;
} ;



#endif // _DISC_COLONY_H
