#ifndef _COLONY_H
#define _COLONY_H

#include "std.h"
#include <stdio.h>
#include <iostream.h>


class colony {
protected:
  real *p ;
  real *dp ;
  real *s_dp ;
  real *B, *A ;
  real total_size ;
  virtual void make_room() ;
  real dp_dt(int i);
public:
  static int default_size ;
  int n, env_n ;
  colony() ;
  colony( int size ) ;
  colony( char *fname ) ;
  colony( colony &oc ) ;
  colony &operator=( colony &oc ) ;
  virtual ~colony() ;
  virtual int read_population( char *fname ) ;
  virtual void uniform_population() ;
  int write( char *fname ) ;
  real &c_a(int i, int j) ;
  real &c_b( int i, int j, int k);
  real &c_p( int i) ;
  real &c_dp( int i ) ;
  int size() ;
  void save_dp() ;
  void retr_dp() ;
  void set_total( real s) ;
  void compute_dp() ;
  void advance( real dt) ;
  void printf_population() ;
  void random_ants() ;
  void random_weights() ;
  virtual void transform( real dt = 0.001) ;
  void modern_read( istream &f );
  void read_from( char *fname ) ;
  virtual void read_cleanup(istream &f) ;
    
  void old_read( FILE *f ) ;
  virtual int read_interpret( char *com, istream &f ) ;
} ;

#endif
